package edu.upvehu.gbg.tap.babel;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

/**
 *
 * @author clase
 */
class Language {
    private final Map<Character, Double> freqs=new HashMap<>();
    private final String id;
    private final String descriptor;
    
    public Language(String id, String descriptor, String filename) throws FileNotFoundException, IOException {
        this.id=id;
        this.descriptor=descriptor;
        try(BufferedReader br=new BufferedReader(new FileReader(filename))){
            int c, count=0;
            while ((c=br.read())!=-1) {
                count++;
                if (freqs.get((char)c)==null) freqs.put((char)c, Double.valueOf(0));
                freqs.put((char)c, freqs.get((char)c)+1);
            }

            for (Character c2:freqs.keySet())
                freqs.put((char)c2, freqs.get((char)c2)/(double)count);
        }
    }
    
    public static double similarity(Language a, Language b) {
        double similarity=0;
        for (Character c:a.freqs.keySet())
            similarity+=b.freqs.get(c)==null?0:Math.min(a.freqs.get(c),b.freqs.get(c));
        return similarity;
    }

    public String getId() {
        return id;
    }

    public String getDescriptor() {
        return descriptor;
    }

    @Override
    public String toString() {
        return "Language{" + "NumFreqs=" + freqs.size() + ", id=" + id + ", descriptor=" + descriptor + '}';
    }

    
    
    
}
