package edu.upvehu.gbg.tap.babel;

import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author clase
 */
public class Test {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args)   {

        //Ids y descriptores de los lenguajes a utilizar (el resto del código funciona para cuantos pongamos aquí
        String[][] langIds={{"spn","Español"},{"gln","Gallego"},{"cln","Catalan"},{"bsq","Euskera"}};
        
        System.out.println("**************  TAREA 1 **************");
        //Los cuatro objetos Language
        Language[] langs= new Language[langIds.length];
        for (int i=0; i<langIds.length;i++) {
            try {
                langs[i]=new Language(langIds[i][0], langIds[i][1], "udhr/txt/"+langIds[i][0]+".txt");
            } catch (IOException ex) {
                Logger.getLogger(Test.class.getName()).log(Level.SEVERE, "No se hapodido leer el fichero del lenguaje "+langIds[i][1]);
            }
        }
        
        //Impresión de la cabecera (el primer lenguaje no tiene columna y queda en blanco)  
        String celdaVacia="        ";
        for (int i=0; i<langIds.length;i++)
            System.out.print(i==0?celdaVacia:String.format("%8s",langIds[i][1]));
        System.out.println();
        //Impresión de los valores (la primera celda es para el descrptor del lenguaje de fila)
        for (int i=0; i<langs.length-1;i++){
            System.out.printf("%8s",langIds[i][1]);
            for (int j=1; j<langs.length;j++)
                System.out.print(j>i?String.format("%8.3f",Language.similarity(langs[i],langs[j])):celdaVacia);
            System.out.println();
        }
        

        System.out.println("**************  TAREA 2 **************");
        //Obtiene los lenguajes
        try {
            Babel babel;
            babel = new Babel("udhr");
            //Para los lenguajes listados 
            for (int i = 0; i < langIds.length; i++) {
                System.out.printf("Lenguajes más próximos al %s:\n", langIds[i][1]);
                for (Language l : babel.findMostSimilars4(langIds[i][0], 10)) // <<------------ PROBAR VERSIONES
                {
                    System.out.printf("%30s: %.3f\n", l.getDescriptor(), Language.similarity(babel.get(langIds[i][0]), l));
                }
                System.out.println();
            }
        } catch (IOException ex) {
            Logger.getLogger(Test.class.getName()).log(Level.SEVERE, null, ex);
        }

    }
    
}
